#include "EasyNextionLibrary.h"
const int buzzer = 9; //buzzer to arduino pin 9
const int dirPin1 = 4;
const int stepPin1 = 5;
const int dirPin2 = 6;
const int stepPin2 = 7;
const int interrupt_pin1 = 3;;;;;;
const int interrupt_pin2 = 2;
const int stepsPerRevolution = 200;
EasyNex myObject(Serial);
volatile byte STATE1;
volatile byte STATE2;
int alarm;
int numberOfPills1;
int numberOfPills2;
int desiredPill1;
int desiredPill2;
int preset1;
int preset2;

void setup() {
  myObject.begin(9600);
  pinMode(stepPin1, OUTPUT);
  pinMode(dirPin1, OUTPUT);
  pinMode(stepPin2, OUTPUT);
  pinMode(dirPin2, OUTPUT);
  pinMode(buzzer, OUTPUT);
  pinMode(interrupt_pin1, INPUT);
  pinMode(interrupt_pin2, INPUT);
  attachInterrupt(digitalPinToInterrupt(interrupt_pin1), interrupt_routine1, RISING);
  attachInterrupt(digitalPinToInterrupt(interrupt_pin2), interrupt_routine2, RISING);
  digitalWrite(dirPin1, LOW);
  digitalWrite(dirPin2, LOW);
  numberOfPills1 = 0;
  numberOfPills2 = 0;
}
/*
   trigger0: dispense preset1
   trigger1: ring alarm
   trigger2: stop alarm
   trigger3: dispense preset2
   trigger4
*/

void loop() {
  myObject.NextionListen();
  if (alarm == 1) {
    ring_buzzer();
  }
  if (STATE1 == HIGH) {
    numberOfPills1 = numberOfPills1+ 1;
    STATE1 = LOW;
  }
  if (STATE2 == HIGH) {
    numberOfPills2 = numberOfPills2+1;
    STATE2 = LOW;
  }
  if (preset1 == 1) {
    if (numberOfPills1 < desiredPill1 ) {
      run_motor1();
      delay(500);
    }
    if (numberOfPills2 < desiredPill2) {
      run_motor2();
      delay(500);
    }
  }
  if (numberOfPills1 == desiredPill1 && numberOfPills2 == desiredPill2) {
      preset1 = 0;
      numberOfPills1 = 0;
      numberOfPills2 = 0;
    }
  if (preset2 == 1) {
    if (numberOfPills1 < desiredPill1 ) {
      run_motor1();
      delay(500);
    }
    if (numberOfPills2 < desiredPill2) {
      run_motor2();
      delay(500);
    }
    
  }
  if (numberOfPills1 == desiredPill1 && numberOfPills2 == desiredPill2) {
      preset2 = 0;
      numberOfPills1 = 0;
      numberOfPills2 = 0;
    }
}

void trigger0() {
  preset1 = 1;
  desiredPill1 = myObject.readNumber("page4.n0.val");
  desiredPill2 = myObject.readNumber("page4.n1.val");
  numberOfPills1 = 0;
  numberOfPills2 = 0;
}

void trigger1() {
  alarm = 1;
}
void trigger2() {
  alarm = 0;
}

void trigger3() {
  desiredPill1 = myObject.readNumber("page5.n0.val");
  desiredPill2 = myObject.readNumber("page5.n1.val");
  preset2 = 1;
  numberOfPills1 = 0;
  numberOfPills2 = 0;

}
void interrupt_routine1() {
  STATE1 = HIGH;
}

void interrupt_routine2() {
  STATE2 = HIGH;
}

void run_motor1() {
  for (int x = 0; x < stepsPerRevolution; x++)
  {
    digitalWrite(stepPin1, HIGH);
    delayMicroseconds(5000);
    digitalWrite(stepPin1, LOW);
    delayMicroseconds(5000);
  }
  delay(1000); // Wait a second
  digitalWrite(stepPin1, LOW);
}

void run_motor2() {
  for (int x = 0; x < stepsPerRevolution; x++)
  {
    digitalWrite(stepPin2, HIGH);
    delayMicroseconds(5000);
    digitalWrite(stepPin2, LOW);
    delayMicroseconds(5000);
  }
  delay(1000); // Wait a second
  digitalWrite(stepPin2, LOW);
}

void ring_buzzer() {
  tone(buzzer, 2000); // Send 2KHz sound signal...
  delay(1000);        // ...for 1 sec
  noTone(buzzer);     // Stop sound...
  delay(1000);        // ...for 1sec
}